
/*
	*= $50

ap		.dsb 2
fp		.dsb 2
sp		.dsb 2
tmp0	.dsb 2
tmp1	.dsb 2
tmp2	.dsb 2
tmp3	.dsb 2
tmp4	.dsb 2
tmp5	.dsb 2
tmp6	.dsb 2
tmp7	.dsb 2
op1		.dsb 2
op2		.dsb 2
tmp		.dsb 2
reg0	.dsb 2
reg1	.dsb 2
reg2	.dsb 2
reg3	.dsb 2
reg4	.dsb 2
reg5	.dsb 2
reg6	.dsb 2
reg7	.dsb 2
*/

	.zero

	*= tmp1

_DY				.dsb 2	; tmp1
_DX				.dsb 2	; tmp2

_E				.dsb 2	; tmp3

	*= tmp1
	
_S0				.dsb 1	; tmp1
_S1				.dsb 1
_B0				.dsb 1	; tmp2
_B1				.dsb 1
_NEW			.dsb 1	; tmp3
_PAT			.dsb 1
	
	*= tmp4

_X0				.dsb 1
_Y0				.dsb 1
_X1				.dsb 1
_Y1				.dsb 1
_FlagFirst		.dsb 1
_OddEvenFlag	.dsb 1
_PolyY0 		.dsb 1
_PolyY1 		.dsb 1
	
	.text

	
#define COLOR_PAPER	4
#define COLOR_INK	3


	.dsb 256-(*&255)




_FillTablesASM
	;
	; Compute the adress of the pattern
	;
	clc
	lda	#<(_Pattern)
	adc	_CurrentPattern
	sta	patch_pattern+1
	lda	#>(_Pattern)
	adc	#0
	sta	patch_pattern+2

	;
	; Compute the screen start adress
	;
	ldy	_PolyY0
	lda	_ScreenPtrLow,y
	sta	tmp0+0
	lda	_ScreenPtrHigh,y
	sta	tmp0+1

draw_loop_y
	;
	; Start Y
	;
	lda	_PolyY0
	and	#1
	cmp	_OddEvenFlag
	bne	draw_end

	;
	; Compute the pattern value
	;
	lda	_PolyY0
	tay
	and	#7
	tax
patch_pattern
	lda	$1234,x
	sta	_PAT

	;
	; Compute the position in the line
	;
	lda	_MinX,y 	; Get X0
	tax
	lda	_Mod6Left,x	; X offset 0
	sta	_B0
	lda	_Div6,x 	; X byte 0
	sta	_S0

	lda	_MaxX,y 	; Get X1
	ldy	_S0		; Start offset
	tax
	lda	_Mod6Right,x	; X offset 1
	sta	_B1

	sec
	lda	_Div6,x 	; X byte 1
	sbc	_S0
	bne	draw_multiple

draw_one
	lda	_B0
	and	_B1
	tax
	eor	#255
	and	(tmp0),y
	sta	_NEW

	txa
	and	_PAT
	ora	_NEW

	sta	(tmp0),y

	jmp draw_end

draw_multiple
	;
	; X=Nb to draw
	;
	tax			; Nb to draw

	lda	_B0
	eor	#255
	and	(tmp0),y
	sta	_NEW

	lda	_B0
	and	_PAT
	ora	_NEW

	sta	(tmp0),y
	iny

	lda	_PAT

	dex
	beq	draw_x_final
draw_loop_x
	sta	(tmp0),y
	iny
	dex
	bne	draw_loop_x

draw_x_final
	lda	_B1
	eor	#255
	and	(tmp0),y
	sta	_NEW

	lda	_B1
	and	_PAT
	ora	_NEW

	sta	(tmp0),y

draw_end
	;
	; End Y
	;
	;
	; Update screen ptr
	;
	clc
	lda	tmp0+0
	adc	#40
	sta	tmp0+0
	lda	tmp0+1
	adc	#0
	sta	tmp0+1

	;
	; Update Y position and local mini/max
	;
	ldy	_PolyY0

	lda	#239
	sta	_MinX,y

	lda	#0
	sta	_MaxX,y

	iny
	sty	_PolyY0

	cpy	_PolyY1
	bcs	end_draw
	jmp	draw_loop_y

end_draw
	;
	; Clear Global Y mini/maxi
	;
	lda	#200
	sta	_PolyY0
	lda	#0
	sta	_PolyY1
	sta	_FlagFirst
	rts



	.dsb 256-(*&255)




_AddLineASM
	lda	_Y0
	cmp	_Y1
	bcc	no_swap_values
	bne	swap_values

	; Null height, so, we leave
	rts

swap_values

	; Swap X's
	ldx	_X0
	ldy	_X1
	stx	_X1
	sty	_X0

	; Swap Y's
	ldx	_Y0
	ldy	_Y1
	stx	_Y1
	sty	_Y0

no_swap_values
	; Store height
	sec
	lda	_Y1
	sbc	_Y0
	sta	_DY

	lda	_Y0
	cmp	_PolyY0
	bcs	no_top
	sta	_PolyY0
no_top

	lda	_Y1
	cmp	_PolyY1
	bcc	no_bottom
	sta	_PolyY1
no_bottom

	;
	; Compute line width
	; And init E
	;
	sec
	lda	_X1
	sbc	_X0
	sta	_DX
	lda	#0
	sbc	#0
	sta	_E
	sta	_E+1
	sta	_DX+1

	;
	; Common inits
	;
	ldy	_Y0
	ldx	_X0

	txa
	cmp	_X1
	bcs	go_compute_right

go_compute_left
	lda	_FlagFirst
	beq	loop_y_left_first_init

loop_y_left
	txa

	cmp	_MinX,y
	bcs	no_min_1
	sta	_MinX,y
no_min_1

	cmp	_MaxX,y
	bcc	no_max_1
	sta	_MaxX,y
no_max_1

	clc
	lda	_E
	adc	_DX
	sta	_E
	lda	_E+1
	adc	_DX+1
	sta	_E+1
	bmi	end_loop_e_left
loop_e_left
	inx
	sec
	lda	_E
	sbc	_DY
	sta	_E
	lda	_E+1
	sbc	#0
	sta	_E+1
	bpl	loop_e_left

end_loop_e_left
	iny
	cpy	_Y1
	bcc	loop_y_left
	rts


go_compute_right
	lda	_FlagFirst
	beq	loop_y_right_first_init
loop_y_right
	txa

	cmp	_MinX,y
	bcs	no_min_2
	sta	_MinX,y
no_min_2

	cmp	_MaxX,y
	bcc	no_max_2
	sta	_MaxX,y
no_max_2

	sec
	lda	_E
	sbc	_DX
	sta	_E
	lda	_E+1
	sbc	_DX+1
	sta	_E+1
	bmi	end_loop_e_right
loop_e_right
	dex
	sec
	lda	_E
	sbc	_DY
	sta	_E
	lda	_E+1
	sbc	#0
	sta	_E+1
	bpl	loop_e_right

end_loop_e_right
	iny
	cpy	_Y1
	bcc	loop_y_right
	rts


loop_y_left_first_init
	lda	#1
	sta	_FlagFirst
	clc
loop_y_left_first
	txa			; NZ, not C
	sta	_MinX,y
	sta	_MaxX,y

	lda	_E
	adc	_DX
	sta	_E
	lda	_E+1
	adc	_DX+1
	sta	_E+1
	bmi	end_loop_e_left_first
loop_e_left_first
	inx
	sec
	lda	_E
	sbc	_DY
	sta	_E
	lda	_E+1
	sbc	#0
	sta	_E+1
	bpl	loop_e_left_first

end_loop_e_left_first
	iny
	cpy	_Y1
	bcc	loop_y_left_first
	rts


loop_y_right_first_init
	lda	#1
	sta	_FlagFirst
loop_y_right_first
	txa
	sta	_MinX,y
	sta	_MaxX,y

	sec
	lda	_E
	sbc	_DX
	sta	_E
	lda	_E+1
	sbc	_DX+1
	sta	_E+1
	bmi	end_loop_e_right_first
loop_e_right_first
	dex
	sec
	lda	_E
	sbc	_DY
	sta	_E
	lda	_E+1
	sbc	#0
	sta	_E+1
	bpl	loop_e_right_first

end_loop_e_right_first
	iny
	cpy	_Y1
	bcc	loop_y_right_first
	rts


_ClearAndSwapFlag
	lda	_OddEvenFlag
	eor	#1
	sta	_OddEvenFlag
	bne	clear_odd

	;
	; Run the generated code (path 1)
	;
clear_even
	ldx	#COLOR_PAPER
	ldy	#COLOR_INK	
	
	lda #1
	sta __patch_loop_clear_scanline_start+1
	lda #39
	sta __patch_loop_clear_scanline_end+1
	jmp	clear_patch

	;
	; Run the generated code (path 2)
	;
clear_odd
	ldx	#COLOR_INK
	ldy	#COLOR_PAPER
	
	lda #1+40
	sta __patch_loop_clear_scanline_start+1
	lda #39+40
	sta __patch_loop_clear_scanline_end+1

clear_patch
	;
	; Contains 200 lines of "STX adr"/"STY adr"
	;
	.dsb 100*6

	;
	; Erase the scan lines
	;
	lda #64
__patch_loop_clear_scanline_start	
	ldy #1
loop_clear_scanline
	; Contains 100 lines of "STA adr,y"
	.dsb 100*3
	iny
__patch_loop_clear_scanline_end
	cpy #40
	beq end_loop_clear_scanline
	jmp loop_clear_scanline
end_loop_clear_scanline
	
	rts
	
; old slow method		
	;
	; Erase the scan lines
	;
	ldx	#100
loop_clear_y

	lda	#64	;+1+4+16
	ldy	#38
loop_clear_x
	sta	(tmp0),y
	dey
	bne	loop_clear_x

	clc
	lda	tmp0
	adc	#80
	sta	tmp0
	lda	tmp0+1
	adc	#0
	sta	tmp0+1

	dex
	bne	loop_clear_y

	rts




; y=offset from "tmp0"
; a=increment
IncrementPointer
.(
	clc
	adc	tmp0+0,y
	sta	tmp0+0,y
	lda	tmp0+1,y
	adc	#0
	sta	tmp0+1,y
	rts
.)


InitClearPatch
.(
	lda	#<($a000+1)
	sta	tmp0
	lda	#>($a000+1)
	sta	tmp0+1

	lda	#<(clear_patch)
	sta	tmp1
	lda	#>(clear_patch)
	sta	tmp1+1
	
	lda	#<(loop_clear_scanline)
	sta	tmp2
	lda	#>(loop_clear_scanline)
	sta	tmp2+1
		
	ldx	#100
init_clear_loop
	;
	; Scan line eraser
	;
	ldy	#0	
	lda	#$99		; "STA adr,y" opcode
	sta	(tmp2),y

	iny
	lda	tmp0
	sta	(tmp2),y	; LOW adr

	iny
	lda	tmp0+1
	sta	(tmp2),y	; HIGH adr
	
	lda #3
	ldy #tmp2-tmp0
	jsr IncrementPointer

	;
	; Even lines
	;
	ldy	#0	
	lda	#$8e		; "STX adr" opcode
	sta	(tmp1),y

	iny
	lda	tmp0
	sta	(tmp1),y	; LOW adr

	iny
	lda	tmp0+1
	sta	(tmp1),y	; HIGH adr

	lda #3
	ldy #tmp1-tmp0
	jsr IncrementPointer

	lda #40
	ldy #tmp0-tmp0
	jsr IncrementPointer
		
	;
	; Odd lines
	;
	ldy	#0
	lda	#$8c		; "STY adr" opcode
	sta	(tmp1),y

	iny
	lda	tmp0
	sta	(tmp1),y	; LOW adr

	iny
	lda	tmp0+1
	sta	(tmp1),y	; HIGH adr

	lda #3
	ldy #tmp1-tmp0
	jsr IncrementPointer

	lda #40
	ldy #tmp0-tmp0
	jsr IncrementPointer
			
	dex
	bne	init_clear_loop
	rts
.)








_InitTables
	lda	#200
	sta	_PolyY0
	lda	#0
	sta	_PolyY1
	sta	_FlagFirst
	sta _OddEvenFlag

	lda	#239
	ldx	#200
loop_init_min
	dex
	sta	_MinX,x
	bne	loop_init_min

	lda	#0
	ldx	#200
loop_init_max
	dex
	sta	_MaxX,x
	bne	loop_init_max
	rts





_DIV6	.byt	0
_MOD6	.byt	0


_ComputeDivMod
	;sei

	lda	#0
	sta	_Y0

	ldx	#0
loop_div
	;
	; Store Div6
	;
	lda	_DIV6
	ldy	_Y0
	sta	_Div6,y

	;
	; Store Mod6
	;
	ldy	_MOD6
	lda	_LeftPattern,y
	ldy	_Y0
	sta	_Mod6Left,y

	ldy	_MOD6
	lda	_RightPattern,y
	ldy	_Y0
	sta	_Mod6Right,y


	;
	; Update Div/Mod
	;
	inc	_MOD6
	lda	_MOD6
	cmp	#6
	bne	no_update
	lda	#0
	sta	_MOD6
	inc	_DIV6
no_update

	;
	; Inc Y
	;
	inc	_Y0
	ldy	_Y0
	bne	loop_div

	ldx	#200
loop_screen_offset
src_1
	lda	#$00
dst_1
	sta	_ScreenPtrLow
src_2
	lda	#$a0
dst_2
	sta	_ScreenPtrHigh

	clc
	lda	src_1+1
	adc	#40
	sta	src_1+1
	lda	src_2+1
	adc	#0
	sta	src_2+1

	inc	dst_1+1
	inc	dst_2+1

	dex
	bne	loop_screen_offset


	jsr	InitClearPatch
	rts










; Calculate some RANDOM values
; Not accurate at all, but who cares ?
; For what I need it's enough.

_RandomValueLow
	 .byt 23
_RandomValue
_RandomValueHigh
	.byt 35


_GetRand
	 lda _RandomValueHigh
	 sta tmp1
	 lda _RandomValueLow
	 asl 
	 rol tmp1
	 asl 
	 rol tmp1
; asl
; rol temp1
; asl
; rol temp1
	 clc
	 adc _RandomValueLow
	 pha
	 lda tmp1
	 adc _RandomValueHigh
	 sta _RandomValueHigh
	 pla
	 adc #$11
	 sta _RandomValueLow
	 lda _RandomValueHigh
	 adc #$36
	 sta _RandomValueHigh
	 jmp	*+3
	 rts



	.dsb 256-(*&255)

_Div6			.dsb 256
_Mod6Left		.dsb 256
_Mod6Right		.dsb 256
_ScreenPtrLow	.dsb 256
_ScreenPtrHigh	.dsb 256

_MinX			.dsb 256	; 200
_MaxX			.dsb 256	; 200

